#include <QtGui>

#include "smalllamegui.h"

smalllamegui::smalllamegui(QWidget *parent): QDialog(parent)
{
	setupUi(this);

	QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));

	QTimer::singleShot(0, this, SLOT(lametest()));
	QTimer::singleShot(0, this, SLOT(ffmpegtest()));
	QTimer::singleShot(0, this, SLOT(normtest()));

	wavIDFormatLineEdit->setText("N-A-T");

	connect(flvOpenButton, SIGNAL(clicked()), this, SLOT(flvOpen()));
	connect(flvSaveButton, SIGNAL(clicked()), this, SLOT(flvSave()));
	connect(flvConvertButton, SIGNAL(clicked()), this, SLOT(flvConvert()));
	connect(normOpenButton, SIGNAL(clicked()), this, SLOT(normOpen()));
	connect(normConvertButton, SIGNAL(clicked()), this, SLOT(normConvert()));
	connect(wavOpenButton, SIGNAL(clicked()), this, SLOT(wavOpen()));
	connect(wavSaveButton, SIGNAL(clicked()), this, SLOT(wavSave()));
	connect(wavConvertButton, SIGNAL(clicked()), this, SLOT(wavConvert()));
	connect(mpOpenButton, SIGNAL(clicked()), this, SLOT(mpOpen()));
	connect(mpSaveButton, SIGNAL(clicked()), this, SLOT(mpSave()));
	connect(mpConvertButton, SIGNAL(clicked()), this, SLOT(mpConvert()));

	connect(&flvProc, SIGNAL(readyReadStandardError()), this, SLOT(flvFortschritt()));
	connect(&flvProc, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(flvProcBeendet(int, QProcess::ExitStatus)));

	connect(&normProc, SIGNAL(readyReadStandardError()), this, SLOT(normFortschritt()));
	connect(&normProc, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(normProcBeendet(int, QProcess::ExitStatus)));

	connect(&wavProc, SIGNAL(readyReadStandardError()), this, SLOT(wavFortschritt()));
	connect(&wavProc, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(wavProcBeendet(int, QProcess::ExitStatus)));

	connect(&mpProc, SIGNAL(readyReadStandardError()), this, SLOT(mpFortschritt()));
	connect(&mpProc, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(mpProcBeendet(int, QProcess::ExitStatus)));

}


// Öffnen der Files und Eintragen in das QTableWidget für flv->wav

void smalllamegui::flvOpen()
{
	QString initialDir = flvOpenLineEdit->text();
	if(initialDir.isEmpty())
		initialDir = QDir::homePath();

	QStringList InpFiles = openDialog(initialDir,"flash-video (*.flv);;All Files(*.*)");

	if(!InpFiles.isEmpty())
		{
		QFileInfo file(InpFiles[0]);
		QString FilePath = InpFiles[0];
		FilePath.remove(file.fileName());

		flvOpenLineEdit->setText(FilePath);
		QString saveDir=flvSaveLineEdit->text();
		if(saveDir.isEmpty())
			flvSaveLineEdit->setText(FilePath);

		flvTableWidget->clear();
		flvTableWidget->setRowCount(0);
		flvTableWidget->setColumnCount(2);
		flvTableWidget->horizontalHeader()->resizeSection(0,440);
		flvTableWidget->horizontalHeader()->resizeSection(1,60);
		flvTableWidget->setHorizontalHeaderItem(0, new QTableWidgetItem("Files"));
		flvTableWidget->setHorizontalHeaderItem(1, new QTableWidgetItem("Status"));

		foreach (QString str, InpFiles)
			{
			str.remove(FilePath);
			flvTableWidget->insertRow(0);
			flvTableWidget->setItem(0,0, new QTableWidgetItem(str));
			}
		flvConvertButton->setEnabled(true);
		flvProgressBar->setValue(0);
		i=0;
		}
}


// Speicherordner für flv->wav auswählen

void smalllamegui::flvSave()
{
	QString initialDir = flvSaveLineEdit->text();
	if(initialDir.isEmpty())
		initialDir = QDir::homePath();

	QString SaveDir = saveDialog(initialDir);

	if(!SaveDir.isEmpty())
		flvSaveLineEdit->setText(SaveDir);
}


// Konvertierungsstart flv->wav

void smalllamegui::flvConvert()
{
	if(flvConvertButton->text()=="Get Wave")
		{
		QString SourceFile;
		QString TargetFile;
	
		jobs = flvTableWidget->rowCount();
	
		flvConvertButton->setText("Stop");
		flvOpenButton->setEnabled(false);
		flvSaveButton->setEnabled(false);
		tabWidget->setTabEnabled(1,false);
		tabWidget->setTabEnabled(2,false);
		tabWidget->setTabEnabled(3,false);
	
		SourceFile = flvOpenLineEdit->text()+flvTableWidget->item(i,0)->text();
		TargetFile = flvSaveLineEdit->text()+QFileInfo(SourceFile).completeBaseName();
		TargetFile += ".wav";
		QStringList arg;
		arg << "-y" << "-i" << SourceFile << "-vn" << "-ar" << "44100" << "-ac" << "2" << TargetFile;

		flvProc.start("ffmpeg", arg);
		}
	else if(flvConvertButton->text()=="Stop")
		{
		flvProc.terminate();
		int x;
		for(x=0;x<jobs;x++)
			{
			if(flvTableWidget->item(x,1)==0)
				{
				flvTableWidget->setItem(x,1, new QTableWidgetItem("N/A"));
				}
			}
		}
}


// flv->wav Process beendet

void smalllamegui::flvProcBeendet(int exitCode, QProcess::ExitStatus exitStatus)
{
	flvConvertButton->setText("Get Wave");
	flvOpenButton->setEnabled(true);
	flvSaveButton->setEnabled(true);
	tabWidget->setTabEnabled(1,true);
	tabWidget->setTabEnabled(2,true);
	tabWidget->setTabEnabled(3,true);
	flvOpenButton->setFocus();

	if(exitStatus==QProcess::CrashExit)
		{
		flvTableWidget->setItem(i,1, new QTableWidgetItem("FAIL!"));
		flvConvertButton->setEnabled(false);
		}
	else if(exitCode!=0)
		{
		flvTableWidget->setItem(i,1, new QTableWidgetItem("STOP!"));
		flvConvertButton->setEnabled(false);
		}
	else	{
		flvTableWidget->setItem(i,1, new QTableWidgetItem("OK."));
		if(i<(jobs-1))
			{
			i++;
			flvConvert();
			}
		else if(i==(jobs-1))
			{
			normTableWidget->clear();
			wavTableWidget->clear();
			normTableWidget->setColumnCount(2);
			wavTableWidget->setColumnCount(2);
			normTableWidget->setRowCount(jobs);
			wavTableWidget->setRowCount(jobs);
			normTableWidget->horizontalHeader()->resizeSection(0,440);
			normTableWidget->horizontalHeader()->resizeSection(1,60);
			wavTableWidget->horizontalHeader()->resizeSection(0,440);
			wavTableWidget->horizontalHeader()->resizeSection(1,60);
			normTableWidget->setHorizontalHeaderItem(0, new QTableWidgetItem("Files"));
			normTableWidget->setHorizontalHeaderItem(1, new QTableWidgetItem("Status"));
			wavTableWidget->setHorizontalHeaderItem(0, new QTableWidgetItem("Files"));
			wavTableWidget->setHorizontalHeaderItem(1, new QTableWidgetItem("Status"));
			wavOpenLineEdit->setText(flvSaveLineEdit->text());
			normOpenLineEdit->setText(flvSaveLineEdit->text());
			wavSaveLineEdit->setText(flvSaveLineEdit->text());
			int x;
			for(x=0;x<jobs;x++)
				{
				QString wavInsert;
				wavInsert = QFileInfo(flvOpenLineEdit->text() +flvTableWidget->item(x,0)->text()).completeBaseName();
				wavInsert += ".wav";
				normTableWidget->setItem(x,0, new QTableWidgetItem(wavInsert));
				wavTableWidget->setItem(x,0, new QTableWidgetItem(wavInsert));
				}
			flvConvertButton->setEnabled(false);
			wavConvertButton->setEnabled(true);
			normConvertButton->setEnabled(true);
			i=0;
			// Message-Box für Fertig
			QApplication::beep();
			QMessageBox::information(this, "small-lame-gui",
					tr("Erstellung der wav-Dateien abgeschlossen!"),
					QMessageBox::Ok);
			}
		}
}


// Öffnen der Files und Eintragen in das QTableWidget für Normalize

void smalllamegui::normOpen()
{
	QString initialDir = normOpenLineEdit->text();
	if(initialDir.isEmpty())
		initialDir = QDir::homePath();

	QStringList InpFiles = openDialog(initialDir,"Wave-Audio (*.wav);;All Files(*.*)");

	if(!InpFiles.isEmpty())
		{
		QFileInfo file(InpFiles[0]);
		QString FilePath = InpFiles[0];
		FilePath.remove(file.fileName());

		normOpenLineEdit->setText(FilePath);

		normTableWidget->clear();
		normTableWidget->setRowCount(0);
		normTableWidget->setColumnCount(2);
		normTableWidget->horizontalHeader()->resizeSection(0,440);
		normTableWidget->horizontalHeader()->resizeSection(1,60);
		normTableWidget->setHorizontalHeaderItem(0, new QTableWidgetItem("Files"));
		normTableWidget->setHorizontalHeaderItem(1, new QTableWidgetItem("Status"));

		foreach (QString str, InpFiles)
			{
			str.remove(FilePath);
			normTableWidget->insertRow(0);
			normTableWidget->setItem(0,0, new QTableWidgetItem(str));
			}
		normConvertButton->setEnabled(true);
		normProgressBar->setValue(0);
		i=0;
		}
}


// Normalize Process starten

void smalllamegui::normConvert()
{
	if(normConvertButton->text()=="Normalize Audio")
		{
		QString SourceFile;
	
		jobs = normTableWidget->rowCount();
	
		normConvertButton->setText("Stop");
		normOpenButton->setEnabled(false);
		tabWidget->setTabEnabled(0,false);
		tabWidget->setTabEnabled(2,false);
		tabWidget->setTabEnabled(3,false);

		SourceFile = normOpenLineEdit->text()+normTableWidget->item(i,0)->text();
		QStringList arg;
		arg << SourceFile;

		normProc.start("normalize-audio", arg);
		}
	else if(normConvertButton->text()=="Stop")
		{
		normProc.terminate();
		int x;
		for(x=0;x<jobs;x++)
			{
			if(normTableWidget->item(x,1)==0)
				{
				normTableWidget->setItem(x,1, new QTableWidgetItem("N/A"));
				}
			}
		}
}


// Normalize Process beendet

void smalllamegui::normProcBeendet(int, QProcess::ExitStatus exitStatus)
{
	normConvertButton->setText("Normalize Audio");
	normOpenButton->setEnabled(true);
	tabWidget->setTabEnabled(0,true);
	tabWidget->setTabEnabled(2,true);
	tabWidget->setTabEnabled(3,true);
	normOpenButton->setFocus();

	if (exitStatus==QProcess::CrashExit)
		{
		normTableWidget->setItem(i,1, new QTableWidgetItem("STOP!"));
		normConvertButton->setEnabled(false);
		}
	else if(exitStatus != QProcess::NormalExit)
		{
		normTableWidget->setItem(i,1, new QTableWidgetItem("FAIL!"));
		normConvertButton->setEnabled(false);
		}
	else	{
		normTableWidget->setItem(i,1, new QTableWidgetItem("OK."));
		if(i<(jobs-1))
			{
			i++;
			normConvert();
			}
		else if(i==(jobs-1))
			{
			normConvertButton->setEnabled(false);
			i=0;
			// Message-Box für Fertig
			QApplication::beep();
			QMessageBox::information(this, "small-lame-gui",
					tr("Normalisierung abgeschlossen!"),
					QMessageBox::Ok);
			}
		}
}


// Öffnen der Files und Eintragen in das QTableWidget für wav->mp3

void smalllamegui::wavOpen()
{
	QString initialDir = wavOpenLineEdit->text();
	if(initialDir.isEmpty())
		initialDir = QDir::homePath();

	QStringList InpFiles = openDialog(initialDir,"Wave-Audio (*.wav);;All Files(*.*)");

	if(!InpFiles.isEmpty())
		{
		QFileInfo file(InpFiles[0]);
		QString FilePath = InpFiles[0];
		FilePath.remove(file.fileName());

		wavOpenLineEdit->setText(FilePath);
		QString saveDir=wavSaveLineEdit->text();
		if(saveDir.isEmpty())
			{
			wavSaveLineEdit->setText(FilePath);
			}

		wavTableWidget->clear();
		wavTableWidget->setRowCount(0);
		wavTableWidget->setColumnCount(2);
		wavTableWidget->horizontalHeader()->resizeSection(0,440);
		wavTableWidget->horizontalHeader()->resizeSection(1,60);
		wavTableWidget->setHorizontalHeaderItem(0, new QTableWidgetItem("Files"));
		wavTableWidget->setHorizontalHeaderItem(1, new QTableWidgetItem("Status"));

		foreach (QString str, InpFiles)
			{
			str.remove(FilePath);
			wavTableWidget->insertRow(0);
			wavTableWidget->setItem(0,0, new QTableWidgetItem(str));
			}
		wavConvertButton->setEnabled(true);
		wavProgressBar->setValue(0);
		i=0;
		}
}


// Speicherordner für wav->mp3 auswählen

void smalllamegui::wavSave()
{
	QString initialDir = wavSaveLineEdit->text();
	if(initialDir.isEmpty())
		initialDir = QDir::homePath();

	QString SaveDir = saveDialog(initialDir);

	if(!SaveDir.isEmpty())
		wavSaveLineEdit->setText(SaveDir);
}


// Konvertierungsstart wav->mp3

void smalllamegui::wavConvert()
{
	if(wavConvertButton->text()=="Convert")
		{
		QString SourceFile;
		QString TargetFile;
	
		jobs = wavTableWidget->rowCount();
	
		wavConvertButton->setText("Stop");
		wavOpenButton->setEnabled(false);
		wavSaveButton->setEnabled(false);
		tabWidget->setTabEnabled(0,false);
		tabWidget->setTabEnabled(1,false);
		tabWidget->setTabEnabled(3,false);

		SourceFile = wavOpenLineEdit->text()+wavTableWidget->item(i,0)->text();
		TargetFile = wavSaveLineEdit->text()+QFileInfo(SourceFile).completeBaseName();
		TargetFile += ".mp3";
		QStringList arg;

		if(CDradioButton->isChecked())
			arg << "--preset" << "cbr" << "256";
		else if(MQradioButton->isChecked())
			arg << "--preset" << "cbr" << "192";
		else if(LQradioButton->isChecked())
			arg << "--preset" << "cbr" << "128";



	// ID3-Tags erstellen

	if(wavTagsCheckBox->isChecked())
		{
		// Zerlegung des Zeichenmusters N-A-T

		QString let1,let2,let3;
		QString id_muster,spacer1,spacer2;
		int x1=-1,x2=-1,x3=-1,anz=0;
		QRegExp sign("[NAT]");

		id_muster=wavIDFormatLineEdit->text();
		x1=id_muster.indexOf(sign,0);
		if(x1!=-1)
			{
			let1=id_muster.mid(x1,1);
			anz++;
			x2=id_muster.indexOf(sign,x1+1);
			if(x2!=-1)
				{
				let2=id_muster.mid(x2,1);
				anz++;
				x3=id_muster.indexOf(sign,x2+1);
				if(x3!=-1)
					{
					let3=id_muster.mid(x3,1);
					anz++;
					}
				}
			}

		// Festlegen der Trennzeichen anhand des Zeichenmusters

		if(anz>1)
			spacer1=id_muster.mid(x1+1,x2-(x1+1));
		if(anz>2)
			spacer2=id_muster.mid(x2+1,x3-(x2+1));


		// Zerlegung der Dateinamen in die Bestandteile anhand der Trennzeichen

		QString id_temp,file_temp;
		int x_temp1,x_temp2;

		file_temp=QFileInfo(wavTableWidget->item(i,0)->text()).completeBaseName();

		if(!spacer1.isEmpty())
			x_temp1=file_temp.indexOf(spacer1,0);
		else
			x_temp1=file_temp.size();

		if(!spacer2.isEmpty())
			x_temp2=file_temp.indexOf(spacer2,x_temp1+1);
		else
			x_temp2=file_temp.size();


		// Zuweisung der entsprechenden ID3-Tags für 1. Buchstaben

		id_temp=file_temp.mid(0,x_temp1);
		if(let1=="N")
			arg << "--tn" << id_temp;
		else if(let1=="A")
			arg << "--ta" << id_temp;
		else
			arg << "--tt" << id_temp;


		// Zuweisung der entsprechenden ID3-Tags für 2. Buchstaben

		if(anz>1)
			{
			id_temp=file_temp.mid(x_temp1+spacer1.size(),x_temp2-(x_temp1+spacer1.size()));
			if(let2=="N")
				arg << "--tn" << id_temp;
			else if(let2=="A")
				arg << "--ta" << id_temp;
			else
				arg << "--tt" << id_temp;
			}


		// Zuweisung der entsprechenden ID3-Tags für 3. Buchstaben

		if(anz>2)
			{
			id_temp=file_temp.mid(x_temp2+spacer2.size());
			if(let3=="N")
				arg << "--tn" << id_temp;
			else if(let3=="A")
				arg << "--ta" << id_temp;
			else
				arg << "--tt" << id_temp;
			}

		arg << "--add-id3v2";

		}

		arg << SourceFile << TargetFile;

		wavProc.start("lame", arg);
		}
	else if(wavConvertButton->text()=="Stop")
		{
		wavProc.terminate();
		int x;
		for(x=0;x<jobs;x++)
			{
			if(wavTableWidget->item(x,1)==0)
				{
				wavTableWidget->setItem(x,1, new QTableWidgetItem("N/A"));
				}
			}
		}
}


// wav->mp3 Process beendet

void smalllamegui::wavProcBeendet(int, QProcess::ExitStatus exitStatus)
{
	wavConvertButton->setText("Convert");
	wavOpenButton->setEnabled(true);
	wavSaveButton->setEnabled(true);
	tabWidget->setTabEnabled(0,true);
	tabWidget->setTabEnabled(1,true);
	tabWidget->setTabEnabled(3,true);
	wavOpenButton->setFocus();

	if (exitStatus==QProcess::CrashExit)
		{
		wavTableWidget->setItem(i,1, new QTableWidgetItem("STOP!"));
		wavConvertButton->setEnabled(false);
		}
	else if(exitStatus != QProcess::NormalExit)
		{
		wavTableWidget->setItem(i,1, new QTableWidgetItem("FAIL!"));
		wavConvertButton->setEnabled(false);
		}
	else	{
		wavTableWidget->setItem(i,1, new QTableWidgetItem("OK."));
		if(i<(jobs-1))
			{
			i++;
			wavConvert();
			}
		else if(i==(jobs-1))
			{
			wavConvertButton->setEnabled(false);
			i=0;
			// Message-Box für Fertig
			QApplication::beep();
			QMessageBox::information(this, "small-lame-gui",
					tr("Konvertierung beendet!"),
					QMessageBox::Ok);
			}
		}
}


// Öffnen der Files und Eintragen in das QTableWidget für mp3->wav

void smalllamegui::mpOpen()
{
	QString initialDir = mpOpenLineEdit->text();
	if(initialDir.isEmpty())
		initialDir = QDir::homePath();

	QStringList InpFiles = openDialog(initialDir,"mp3-Files (*.mp3);;All Files(*.*)");

	if(!InpFiles.isEmpty())
		{
		QFileInfo file(InpFiles[0]);
		QString FilePath = InpFiles[0];
		FilePath.remove(file.fileName());

		mpOpenLineEdit->setText(FilePath);
		QString saveDir=mpSaveLineEdit->text();
		if(saveDir.isEmpty())
			{
			mpSaveLineEdit->setText(FilePath);
			}

		mpTableWidget->clear();
		mpTableWidget->setRowCount(0);
		mpTableWidget->setColumnCount(2);
		mpTableWidget->horizontalHeader()->resizeSection(0,440);
		mpTableWidget->horizontalHeader()->resizeSection(1,60);
		mpTableWidget->setHorizontalHeaderItem(0, new QTableWidgetItem("Files"));
		mpTableWidget->setHorizontalHeaderItem(1, new QTableWidgetItem("Status"));

		foreach (QString str, InpFiles)
			{
			str.remove(FilePath);
			mpTableWidget->insertRow(0);
			mpTableWidget->setItem(0,0, new QTableWidgetItem(str));
			}
		mpConvertButton->setEnabled(true);
		mpProgressBar->setValue(0);
		i=0;
		}
}


// Speicherordner für mp3->wav auswählen

void smalllamegui::mpSave()
{
	QString initialDir = mpSaveLineEdit->text();
	if(initialDir.isEmpty())
		initialDir = QDir::homePath();

	QString SaveDir = saveDialog(initialDir);

	if(!SaveDir.isEmpty())
		mpSaveLineEdit->setText(SaveDir);
}


// Konvertierungsstart mp3->wav

void smalllamegui::mpConvert()
{
	if(mpConvertButton->text()=="Back to Wave")
		{
		QString SourceFile;
		QString TargetFile;
	
		jobs = mpTableWidget->rowCount();
	
		mpConvertButton->setText("Stop");
		mpOpenButton->setEnabled(false);
		mpSaveButton->setEnabled(false);
		tabWidget->setTabEnabled(0,false);
		tabWidget->setTabEnabled(1,false);
		tabWidget->setTabEnabled(2,false);

		SourceFile = mpOpenLineEdit->text()+mpTableWidget->item(i,0)->text();
		TargetFile = mpSaveLineEdit->text()+QFileInfo(SourceFile).completeBaseName();
		TargetFile += ".wav";
		QStringList arg;

		arg << "--decode" << SourceFile << TargetFile;

		mpProc.start("lame", arg);
		}
	else if(mpConvertButton->text()=="Stop")
		{
		mpProc.terminate();
		int x;
		for(x=0;x<jobs;x++)
			{
			if(mpTableWidget->item(x,1)==0)
				{
				mpTableWidget->setItem(x,1, new QTableWidgetItem("N/A"));
				}
			}
		}
}


// mp3->wav Process beendet

void smalllamegui::mpProcBeendet(int, QProcess::ExitStatus exitStatus)
{
	mpConvertButton->setText("Back to Wave");
	mpOpenButton->setEnabled(true);
	mpSaveButton->setEnabled(true);
	tabWidget->setTabEnabled(0,true);
	tabWidget->setTabEnabled(1,true);
	tabWidget->setTabEnabled(2,true);
	mpOpenButton->setFocus();

	if (exitStatus==QProcess::CrashExit)
		{
		mpTableWidget->setItem(i,1, new QTableWidgetItem("STOP!"));
		mpConvertButton->setEnabled(false);
		}
	else if(exitStatus != QProcess::NormalExit)
		{
		mpTableWidget->setItem(i,1, new QTableWidgetItem("FAIL!"));
		mpConvertButton->setEnabled(false);
		}
	else	{
		mpTableWidget->setItem(i,1, new QTableWidgetItem("OK."));
		if(i<(jobs-1))
			{
			i++;
			mpConvert();
			}
		else if(i==(jobs-1))
			{
			mpConvertButton->setEnabled(false);
			mpProgressBar->setValue(100);
			// Message-Box für Fertig
			QApplication::beep();
			QMessageBox::information(this, "small-lame-gui",
					tr("Dekodierung abgeschlossen!"),
					QMessageBox::Ok);
			}
		}
}


// QProgessBar (Fortschrittsbalken) für flv->wav Werte eintragen

void smalllamegui::flvFortschritt()
{
	QByteArray data= flvProc.readAllStandardError();
	QString text= QString::fromLocal8Bit(data);

	if(text.contains("Duration:"))
		firsttime=1;
	
	if(firsttime==1)
	{
	QRegExp reg("..:..:..\\...");
	if(text.contains(reg))
		{
		QString time=reg.cap();

		QString stunde=time.mid(0,2);
		QString minute=time.mid(3,2);
		QString sekunde=time.mid(6,5);

		double std=stunde.toDouble();
		double min=minute.toDouble();
		double sek=sekunde.toDouble();

		flvGesamtzeit=(std*3600)+(min*60)+sek;
		firsttime=0;
		}
	}

	QRegExp regtime("time=..:..:..\\...");
	if(text.contains(regtime))
		{
		int posakt=text.indexOf("time");
		QString aktzeit=text.mid(posakt+5,11);
		QString akt_std=aktzeit.mid(0,2);
		QString akt_min=aktzeit.mid(3,2);
		QString akt_sek=aktzeit.mid(6);

		double tmp_std,tmp_min,tmp_sek;
		tmp_std=akt_std.toDouble();
		tmp_min=akt_min.toDouble();
		tmp_sek=akt_sek.toDouble();

		double poszeit=(tmp_std*60*60)+(tmp_min*60)+tmp_sek;

		flvProz=poszeit*100/flvGesamtzeit;

		flvProgressBar->setValue(flvProz);
		}

	else if(text.contains("time"))
		{
		int posakt=text.indexOf("time");
		QString aktzeit=text.mid(posakt+5,5);
		double poszeit=aktzeit.toDouble();
		flvProz=poszeit*100/flvGesamtzeit;

		flvProgressBar->setValue(flvProz);
		}
}


// QProgessBar (Fortschrittsbalken) für Normalize Werte eintragen

void smalllamegui::normFortschritt()
{
	QByteArray data= normProc.readAllStandardError();
	QString text= QString::fromLocal8Bit(data);

	QRegExp reg("[0-9]{1,3}%");
	if(text.contains(reg))
		{
		QString normalize=reg.cap();
		normalize.chop(1);
		normProz = normalize.toInt();

		normProgressBar->setValue(normProz);
		}
}


// QProgessBar (Fortschrittsbalken) für wav->mp3 Werte eintragen

void smalllamegui::wavFortschritt()
{
	QByteArray data= wavProc.readAllStandardError();
	QString text= QString::fromLocal8Bit(data);

	QRegExp reg("[0-9]{1,3}%");
	if(text.contains(reg))
		{
		QString lameProz=reg.cap();
		lameProz.chop(1);
		wavProz = lameProz.toInt();

		wavProgressBar->setValue(wavProz);
		}
}


// QProgessBar (Fortschrittsbalken) für mp3->wav Werte eintragen

void smalllamegui::mpFortschritt()
{
	QByteArray data= mpProc.readAllStandardError();
	QString text= QString::fromLocal8Bit(data);

	double zahl,gesamt;
	double pos1,pos2,pos3;

	if(text.contains("Frame"))
		{
		pos2=text.indexOf("/");
		pos1=text.lastIndexOf(" ",pos2);
		pos3=text.indexOf(" ",pos2);
		QString frames=text.mid(pos1+1,pos2-pos1-1);
		QString gzeit=text.mid(pos2+1,pos3-pos2-1);
		zahl=frames.toDouble();
		gesamt=gzeit.toDouble();
		mpProz=zahl*100/gesamt;
		mpProgressBar->setValue(mpProz);
		}
}


// Test nach dem Starten ob ffmpeg verfügbar, wenn nicht mit QMessageBox beenden

void smalllamegui::ffmpegtest()
{
	QFileInfo test("/usr/bin/ffmpeg");
	if(!test.exists())
		{
		tabWidget->setTabEnabled(0,false);
		font.setPointSize(12);
		QMessageBox msgBox;
		msgBox.setStandardButtons(QMessageBox::Ok);
		msgBox.setFont(font);
		msgBox.setIcon(QMessageBox::Critical);
		msgBox.setWindowTitle("small-lame-gui");
		msgBox.setText(tr("<b>Fehler: ffmpeg nicht gefunden!</b><br><br>"
			"small-lame-gui benötigt ffmpeg zum extrahieren<br>"
			"der Audiospur aus Flash-Filmen.<br>"
			"Diese Funktion wird nicht zur Verfügung stehen.<br>"
			"Bitte installieren Sie das Paket ffmpeg."));
		msgBox.exec();
		}
}


// Test nach dem Starten ob lame verfügbar, wenn nicht mit QMessageBox beenden

void smalllamegui::lametest()
{
	QFileInfo test("/usr/bin/lame");
	if(!test.exists())
		{
		font.setPointSize(12);
		QMessageBox msgBox;
		msgBox.setStandardButtons(QMessageBox::Ok);
		msgBox.setFont(font);
		msgBox.setIcon(QMessageBox::Critical);
		msgBox.setWindowTitle("small-lame-gui");
		msgBox.setText(tr("<b>Fehler: lame nicht gefunden!</b><br><br>"
			"small-lame-gui benötigt ffmpeg und lame.<br>"
			"Bitte installieren Sie die Anwendungen.<br>"
			"Das Programm wird geschlossen."));
		msgBox.exec();
		QCoreApplication::exit(2);
		}
}

// Test nach dem Starten ob normalize-audio verfügbar, wenn nicht keine Normalize Funktion

void smalllamegui::normtest()
{
	QFileInfo test("/usr/bin/normalize-audio");
	if(!test.exists())
		{
		tabWidget->setTabEnabled(1,false);
		font.setPointSize(12);
		QMessageBox msgBox;
		msgBox.setStandardButtons(QMessageBox::Ok);
		msgBox.setFont(font);
		msgBox.setIcon(QMessageBox::Critical);
		msgBox.setWindowTitle("small-lame-gui");
		msgBox.setText(tr("<b>Fehler: normalize-audio nicht gefunden!</b><br><br>"
			"small-lame-gui benötigt normalize-audio für die<br>"
			"automatische Anpassung (normalisieren) der Lautstärke.<br>"
			"Diese Funktion wird nicht zur Verfügung stehen.<br>"
			"Bitte installieren Sie das Paket normalize-audio."));
		msgBox.exec();
		}
}




// Sortierung für File-Einträge in die QTableWidget

 bool caseInsensitiveLessThan(const QString &s1, const QString &s2)
 {
     return s1.toLower() > s2.toLower();
 }


// Member-Funktion öffnen Dialog

QStringList smalllamegui::openDialog(QString initialDir,const char* Filter)
{
	QStringList InpFiles = QFileDialog::getOpenFileNames(
		this,
		"Open File(s)",
		initialDir,
		Filter);

	qSort(InpFiles.begin(),InpFiles.end(),caseInsensitiveLessThan);
	return InpFiles;
}


// Member-Funktion speichern Dialog

QString smalllamegui::saveDialog(QString initialDir)
{
	QString SaveDir = QFileDialog::getExistingDirectory(
		this,
		tr("Save in Folder"),
		initialDir,
		QFileDialog::DontConfirmOverwrite);

	if(!SaveDir.endsWith("/"))
		SaveDir = SaveDir+"/";

	return SaveDir;
}

